#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.utils import *
import os

def cache_path(path):
    dirname, basename = os.path.split(path)
    cachedir = os.path.join(dirname, '.cache')
    if not os.path.exists(cachedir):
        os.mkdir(cachedir)
    return os.path.join(cachedir, basename)

def cache_check(req):
    if req.args or req.option.cachetime == 0:
        return ''
    path = cache_path(req.filename)
    if not os.path.exists(path):
        return ''
    if req.request_time - os.path.getmtime(path) > req.option.cachetime:
        log(3, '%s removed' % path)
        os.remove(path)
        return ''
    log(3, '%s hit' % path)
    return open(path).read()

def cache_save(req, data):
    if req.args or req.option.cachetime == 0:
        return
    path = cache_path(req.filename)
    open(path, 'w').write(data)
