#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_obj
from pythonite.utils import log

class Page:
    def __init__(self, req, items, nipp):
        self.req = req
        try:
            num = int(req.query.page)
        except ValueError:
            num = 1
        self.num = num
        if nipp < 0:
            items.reverse()
            nipp = -nipp
        self.items = items[(num-1)*nipp:num*nipp] # items in the page
        self.ni = len(items) # number of items
        self.nipp = nipp # number of items per page
        self.np = (len(items)+nipp-1)//nipp # number of pages
        if num == 1:
            self.prev = '?page='+str(num)
        else:
            self.prev = '?page='+str(num-1)
        if num == self.np:
            self.next = '?page='+str(num)
        else:
            self.next = '?page='+str(num+1)
        log(1, 'page done')

register_obj('Page', Page, None)
