#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_ext
from pythonite.objects.file_obj import File

class Text(File):
    objtype = 'text'
    def __init__(self, path, context):
        self.path = path
        self.context = context
        file = open(self.path)
        while 1:
            line = file.readline()
            if not line or ':' not in line:
                break
            key, val = line.split(':', 1)
            setattr(self, key.lower(), val.strip())
        if not line.strip():
            line = ''
        self.body = line + file.read()
        file.close()
    def get_escape(self):
        data = self.body
        data = data.replace('&', '&amp;')
        data = data.replace('<', '&lt;')
        data = data.replace('>', '&gt;')
        return data
    def get_lines(self):
        return self.body.rstrip().split('\n')

register_ext('.txt', Text)
